Overview | Package | Class | Tree | Deprecated | Index | Help
| Copyright © 2000, 2009, Oracle and/or its affiliates. All rights reserved.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.bea.netuix.application.view
Interface BookView

All Superinterfaces
  ChildView, MarkupBasedView, NavigableView, ParentView, PlaceableView, ProxiedEntityView, Serializable, ThemedMarkupBasedView, View

    public interface BookView

extends ParentView, NavigableView, PlaceableView, ThemedMarkupBasedView, ProxiedEntityView

The book view represents a book and all its contents. Books aggregate a set of navigables. A navigable is either a book or a page, so books can contain pages but may also contain other books. There is no theoretical limit to the number of navigables a book may contain.

"Views" are deep copy immutable objects. Unlike "Definitions" and "Instances" Views cannot be modified by the developer. An Instance or a Definition however can always be obtained from the view. The persistence APIs provide coarse grain and fine grain getters, but only fine grain setters. If you are interested in an object and all its children then retrieve the View. If you are only interested in the immediate object and don't care about its children then retrieve the Definition.

A book can be obtained in "deep" (the default) or "shallow" mode. In shallow mode, the child book, page, and navigable arrays are null. The child navigables can be retrieved by a PagedResult using getPagedNavigableViews. In shallow mode, all of the methods for searching for child page or book views will return null, and count methods will return zero. The deep view is therefore more convenient to use, but the shallow view can be much lighter-weight. By default, BookViews are constructed in deep mode. There are specific methods in the portal persistence API to retrieve shallow book views. If a BookView was constructed in shallow mode, then any child BookView or PageView obtained by calling getPagedNavigableViews will be shallow.

See Also
  `View`
  This interface is intended to be implemented only by Oracle Weblogic Portal. Oracle Systems reserves the right to add abstract methods to this interface without notice. Implementations of this interface by other parties must not be expected to compile without change in future versions of Oracle Weblogic Portal.

Field Summary
`static short` | `ORIENTATION_BOTTOM` Constant enum to represent a book's menu location.
`static short` | `ORIENTATION_LEFT` Constant enum to represent a book's menu location.
`static short` | `ORIENTATION_RIGHT` Constant enum to represent a book's menu location.
`static short` | `ORIENTATION_TOP` Constant enum to represent a book's menu location.

Fields inherited from interface com.bea.netuix.application.view.NavigableView
`ALIGNMENT_LEFT, ALIGNMENT_RIGHT`

Fields inherited from interface com.bea.netuix.application.view.ProxiedEntityView
`HAS_PROXY_INFO, NO_PROXY_INFO, NOT_AVAILABLE`

Method Summary
`int` | `getBookCount()` Get the number of child books of this book.
`BookDefinition` | `getBookDefinition()` Retrieve the associated `BookDefinition` from this Book View.
`BookDefinitionId` | `getBookDefinitionId()` Getter for the book definition id.
`BookGroupId` | `getBookGroupId()` Getter for the book's book group id.
`BookInstance` | `getBookInstance()` Retrieve the associated `BookInstance` from this Book View.
`BookInstanceId` | `getBookInstanceId()` Getter for the book instance id.
`BookView` | `getBookView(BookDefinitionId bookDefinitionId)` Gets an immediate child book with a given definition Id.
`BookView` | `getBookView(BookInstanceId bookInstanceId)` Gets an immediate child book with a given instance ID.
`BookView` | `getBookView(String definitionLabel)` Gets an immediate child book with a given label.
`BookView` | `getBookViewRecursive(BookDefinitionId bookDefinitionId)` Gets any child book with a given definition id, searching the entire tree of nested books and pages.
`BookView` | `getBookViewRecursive(BookInstanceId bookInstanceId)` Gets any child book with a given instance ID, searching the entire tree of nested books and pages.
`BookView` | `getBookViewRecursive(String bookDefinitionLabel)` Gets any child book with a given label, searching the entire tree of nested books and pages.
`BookView[]` | `getBookViews()` Get the child books of this book.
`String` | `getDefaultPage()` Retrieve the definition label of the default page for this book.
`short` | `getMenuOrientation()` Returns the menu's orientation.
`MenuView` | `getMenuView()` Get the child menu View class for this book.
`int` | `getNavigableCount()` Get the number of child navigables (books or pages) of this book.
`NavigableView` | `getNavigableView(NavigableDefinitionId navigableDefinitionId)` Gets the child navigable (book or page) with a given label, searching only the immediate children and pages.
`NavigableView` | `getNavigableView(NavigableInstanceId navigableInstanceId)` Gets the child navigable (book or page) with a given label, searching only the immediate children and pages.
`NavigableView` | `getNavigableView(String definitionLabel)` Gets the child navigable (book or page) with a given label, searching only the immediate children and pages.
`NavigableView[]` | `getNavigableViews()` Get the child navigables (books or pages) of this book.
`int` | `getPageCount()` Get the number of child pages of this book.
`SortableFilterablePagedResult<NavigableView>` | `getPagedNavigableViews(int pageSize, String resourcePrefix)` Get the child navigables (books or pages) of this book.
`PageView` | `getPageView(PageDefinitionId pageDefinitionId)` Gets an immediate child page with a given definition ID.
`PageView` | `getPageView(PageInstanceId pageInstanceId)` Gets an immediate child page with a given instance ID.
`PageView` | `getPageView(String definitionLabel)` Gets an immediate child page with a given label.
`PageView` | `getPageViewRecursive(PageDefinitionId pageDefinitionId)` Gets the PageView with a given pageDefinitionId, searching the entire tree of nested books and pages.
`PageView` | `getPageViewRecursive(PageInstanceId pageInstanceId)` Gets the PageView with a given instance id, searching the entire tree of nested books and pages.
`PageView` | `getPageViewRecursive(String pageDefinitionLabel)` Gets the PageView with a given label, searching the entire tree of nested books and pages.
`PageView[]` | `getPageViews()` Get the child pages of this book.
`PlacementId` | `getPlacementId()` Getter for the book's placement id.
`PortletView` | `getPortletViewRecursive(PortletInstanceId portletInstanceId)` Gets the PortletView with a given instance ID, searching the entire tree of nested books and pages.
`PortletView` | `getPortletViewRecursive(String portletInstanceLabel)` Gets the PortletView with a given instance label, searching the entire tree of nested books and pages.
`String` | `getWebAppName()` Return the name of the webapp that this book is associated with.

Methods inherited from interface com.bea.netuix.application.view.ParentView
`getBookViewsRecursive, getPageViewsRecursive`

Methods inherited from interface com.bea.netuix.application.view.NavigableView
`getAlignment, getDefinitionLabel, getLocalizationResourceView, getMenuPosition, getNavigableDefinition, getNavigableInstance, isDefaultPage, isHidden, isPublic`

Methods inherited from interface com.bea.netuix.application.view.View
`getDescription, getTitle`

Methods inherited from interface com.bea.netuix.application.view.PlaceableView
`getDefinitionLabel, getLabel, getLocalizationResourceView, getPlaceableDefinition, getPlaceableInstance, getPlaceholderDefinitionId, getPlaceholderPosition`

Methods inherited from interface com.bea.netuix.application.view.View
`getDescription, getTitle`

Methods inherited from interface com.bea.netuix.application.view.ThemedMarkupBasedView
`getThemeView`

Methods inherited from interface com.bea.netuix.application.view.MarkupBasedView
`getMarkupView`

Methods inherited from interface com.bea.netuix.application.view.View
`getDescription, getTitle`

Methods inherited from interface com.bea.netuix.application.view.ProxiedEntityView
`getProviderName, getProxiedEntityId, hasProxyInfo`

Field Detail

### ORIENTATION_TOP

    static final short ORIENTATION_TOP

  Constant enum to represent a book's menu location.

  See Also
    Constants Summary

### ORIENTATION_LEFT

    static final short ORIENTATION_LEFT

  Constant enum to represent a book's menu location.

  See Also
    Constants Summary

### ORIENTATION_RIGHT

    static final short ORIENTATION_RIGHT

  Constant enum to represent a book's menu location.

  See Also
    Constants Summary

### ORIENTATION_BOTTOM

    static final short ORIENTATION_BOTTOM

  Constant enum to represent a book's menu location.

  See Also
    Constants Summary

Method Detail

### getBookInstanceId

    BookInstanceId getBookInstanceId()

  Getter for the book instance id. The instance id is the primary key value for the book instance in the PF_BOOK_INSTANCE table. A Book Definition may have many instances. These instance are created when administrators or users customize their portal. A Book Definition always has at least one instance namely the "primary" instance.

  Returns
    a non-null unique definition id. This value should never be null as views are obtained via the persistence API.

### getBookDefinitionId

    BookDefinitionId getBookDefinitionId()

  Getter for the book definition id. The definition id is the primary key value for the book definition in the PF_BOOK_DEFINITION table. A Book Definition may have many instances. These instance are created when administrators or users customize their portal. A Book Definition always has at least one instance, namely the "primary" instance.

  Returns
    a non-null unique definition id. This value should never be null as views are obtained via the persistence API.

### getPlacementId

    PlacementId getPlacementId()

  Getter for the book's placement id. The placement id represents a unique placement of a book on a page. Pages may contain Books and Portlets. If this book is placed on a Page then this placement id represents the primary key value of the PF_PLACEMENT.PLACEMENT_ID value in the database. Note: this book might not have been placed on a page as it may be place on another book or may be the main book of the desktop. Also, if this view was obtained directly and not from a parent view object then this value may also be null.

  Specified by:
    `getPlacementId` in interface `PlaceableView`
  Returns
    the placement id if this book is placed on a page and this BookView object was retrieved from a higher-level view object (for example by DesktopView.getBookView()).

### getBookGroupId

    BookGroupId getBookGroupId()

  Getter for the book's book group id. The book group id represents a unique placement of a book on a book. Books may contain Books just like they may contain Pages. If this book is placed on a Book then this book group id represents the primary key value of the PF_BOOK_GROUP.BOOK_GROUP_ID value in the database. Note: this book might not have been placed on a book as it may be placed on a page. Also, if this view was obtained directly and not from a parent view object then this value may also be null.

  Specified by:
    `getBookGroupId` in interface `NavigableView`
  Returns
    the book group id if this book is placed on a page and this BookView object was retrieved from a higher level view object (for example BookView.getBookViews()).

### getBookInstance

    BookInstance getBookInstance()

  Retrieve the associated `BookInstance` from this Book View. Book Views are immutable but Instances and Definitions are not. Therefore it is often necessary to retrieve the instance from the view in order to update its values and then in turn call the persistence API.

  Returns
    a non-null Book Instance.

### getBookDefinition

    BookDefinition getBookDefinition()

  Retrieve the associated `BookDefinition` from this Book View. Book Views are immutable but Instances and Definitions are not. Therefore it is often necessary to retrieve the definition from the view in order to update its values and then in turn call the persistence API.

  Returns
    a non-null Book Definition.

### getDefaultPage

    String getDefaultPage()

  Retrieve the definition label of the default page for this book. It is important to note that Book can act like pages on a parent book so this method may retrieve the definition label of a book.

  Returns
    the definition label of the page or book that is the default for this parent book.

### getMenuView

    MenuView getMenuView()

  Get the child menu View class for this book. Menus are optional on a book so this may return null.

  Returns
    the child menu view if this book has a menu, otherwise null.

### getMenuOrientation

    short getMenuOrientation()

  Returns the menu's orientation. The orientation is a hint to the book and menu skeleton to render the menu at the top, left, right or bottom of the book. Since this is only a hint to the book/menu skeleton, if the skeleton does not support it, it will have no effect.

  Returns
    `ORIENTATION_TOP, ORIENTATION_LEFT, ORIENTATION_RIGHTT, ORIENTATION_BOTTOM`

### getBookViews

    BookView[] getBookViews()

  Get the child books of this book. This method returns immediate children only.

  Returns
    returns the immediate list of child books if there are any otherwise null.

### getBookCount

    int getBookCount()

  Get the number of child books of this book. This method counts immediate children only.

  Returns
    the number of child books.

### getPageViews

    PageView[] getPageViews()

  Get the child pages of this book. This method returns immediate children only.

  Returns
    returns the immediate list of child pages if there are any otherwise null.

### getPageCount

    int getPageCount()

  Get the number of child pages of this book. This method counts immediate children only.

### getNavigableViews

    NavigableView[] getNavigableViews()

  Get the child navigables (books or pages) of this book. This method returns immediate children only. The return array is sorted based on menu position.

  Returns
    a sorted array of child books and pages.

### getPagedNavigableViews

    SortableFilterablePagedResult<NavigableView> getPagedNavigableViews(int pageSize,
                                                                        String resourcePrefix)
                                                                        throws RemoteException

  Get the child navigables (books or pages) of this book. This method returns immediate children only. The return iterator is sorted based on menu position. This method is logically equivalent to `getNavigableViews`. You should call this method if this view was created in shallow mode; otherwise it is more faster and convenient to call `getNavigableViews`. The returned PagedResult is sortable and filterable on the field "TITLE" and supports these filter methods:
  - FilterMethod.UNFILTERED
  - FilterMethod.BEGINS_WITH
  - FilterMethod.ENDS_WITH
  - FilterMethod.CONTAINS
  - FilterMethod.EQUALS
  However, the reSort and reFilter methods on the returned PageResult ignore their locale arguments. If you want to requery with a different locale, you should call this method again after setting the desired locale in the CustomizationContext.

  Returns
    a PagedResult of child books and pages sorted by menu position.
  Throws
    `RemoteException`

### getNavigableCount

    int getNavigableCount()

  Get the number of child navigables (books or pages) of this book. This method counts immediate children only.

  Returns
    the number of immediate navigables. This method returns the same value as getBookCount() + getPageCount();

### getBookView

    BookView getBookView(String definitionLabel)

  Gets an immediate child book with a given label.

  Specified by:
    `getBookView` in interface `ParentView`
  Parameters
    `definitionLabel` - of the child we are looking for.
  Returns
    the book view if it exists otherwise null.

### getPageView

    PageView getPageView(String definitionLabel)

  Gets an immediate child page with a given label.

  Specified by:
    `getPageView` in interface `ParentView`
  Parameters
    `definitionLabel` - of the child we are looking for.
  Returns
    the page view if it exists otherwise null.

### getBookView

    BookView getBookView(BookInstanceId bookInstanceId)

  Gets an immediate child book with a given instance ID.

  Parameters
    `bookInstanceId` - of the child we are looking for.
  Returns
    the child book view or null if none are found.

### getBookView

    BookView getBookView(BookDefinitionId bookDefinitionId)

  Gets an immediate child book with a given definition Id.

  Parameters
    `bookDefinitionId` - of the child book we are looking for.
  Returns
    the child book view or null if none are found.

### getBookViewRecursive

    BookView getBookViewRecursive(BookInstanceId bookInstanceId)

  Gets any child book with a given instance ID, searching the entire tree of nested books and pages.

  Specified by:
    `getBookViewRecursive` in interface `ParentView`
  Parameters
    `bookInstanceId` - of the child book we are looking for.
  Returns
    the child book view or null if none are found.

### getBookViewRecursive

    BookView getBookViewRecursive(BookDefinitionId bookDefinitionId)

  Gets any child book with a given definition id, searching the entire tree of nested books and pages.

  Specified by:
    `getBookViewRecursive` in interface `ParentView`
  Parameters
    `bookDefinitionId` - of the child we are looking for.
  Returns
    the child book view or null if none are found.

### getBookViewRecursive

    BookView getBookViewRecursive(String bookDefinitionLabel)

  Gets any child book with a given label, searching the entire tree of nested books and pages.

  Specified by:
    `getBookViewRecursive` in interface `ParentView`
  Parameters
    `bookDefinitionLabel` - of the child we are looking for.
  Returns
    the child book view or null if none are found.

### getPageView

    PageView getPageView(PageInstanceId pageInstanceId)

  Gets an immediate child page with a given instance ID. Returns null if no such page is found.

  Parameters
    `pageInstanceId` - of the child page we are looking for.
  Returns
    the child page view or null if none are found.

### getPageView

    PageView getPageView(PageDefinitionId pageDefinitionId)

  Gets an immediate child page with a given definition ID.

  Parameters
    `pageDefinitionId` - of the child page we are looking for.
  Returns
    the child page view or null if none are found.

### getPageViewRecursive

    PageView getPageViewRecursive(PageInstanceId pageInstanceId)

  Gets the PageView with a given instance id, searching the entire tree of nested books and pages.

  Specified by:
    `getPageViewRecursive` in interface `ParentView`
  Parameters
    `pageInstanceId` - of the child page we are looking for.
  Returns
    the child page view or null if none are found.

### getPageViewRecursive

    PageView getPageViewRecursive(PageDefinitionId pageDefinitionId)

  Gets the PageView with a given pageDefinitionId, searching the entire tree of nested books and pages.

  Specified by:
    `getPageViewRecursive` in interface `ParentView`
  Parameters
    `pageDefinitionId` - of the child page we are looking for.
  Returns
    the child page view or null if none are found.

### getPageViewRecursive

    PageView getPageViewRecursive(String pageDefinitionLabel)

  Gets the PageView with a given label, searching the entire tree of nested books and pages.

  Specified by:
    `getPageViewRecursive` in interface `ParentView`
  Parameters
    `pageDefinitionLabel` - of the child page we are looking for.
  Returns
    the child page view or null if none are found.

### getPortletViewRecursive

    PortletView getPortletViewRecursive(PortletInstanceId portletInstanceId)

  Gets the PortletView with a given instance ID, searching the entire tree of nested books and pages.

  Specified by:
    `getPortletViewRecursive` in interface `ParentView`
  Parameters
    `portletInstanceId` - of the child portlet we are looking for.
  Returns
    the child portlet view or null if none are found.

### getPortletViewRecursive

    PortletView getPortletViewRecursive(String portletInstanceLabel)

  Gets the PortletView with a given instance label, searching the entire tree of nested books and pages.

  Specified by:
    `getPortletViewRecursive` in interface `ParentView`
  Parameters
    `portletInstanceLabel` - of the child portlet we are looking for.
  Returns
    the child portlet view or null if none are found.

### getNavigableView

    NavigableView getNavigableView(String definitionLabel)

  Gets the child navigable (book or page) with a given label, searching only the immediate children and pages.

  Parameters
    `definitionLabel` - of the child book or page.
  Returns
    the child navigable view or null if none are found.

### getNavigableView

    NavigableView getNavigableView(NavigableDefinitionId navigableDefinitionId)

  Gets the child navigable (book or page) with a given label, searching only the immediate children and pages.

  Parameters
    `navigableDefinitionId` - (BookDefinitionId or PageDefinitionId) of the child book or page.
  Returns
    the child navigable view or null if none are found.

### getNavigableView

    NavigableView getNavigableView(NavigableInstanceId navigableInstanceId)

  Gets the child navigable (book or page) with a given label, searching only the immediate children and pages.

  Parameters
    `navigableInstanceId` - (BookInstanceId or PageInstanceId) of the child book or page.
  Returns
    the child navigable view or null if none are found.

### getWebAppName

    String getWebAppName()

  Return the name of the webapp that this book is associated with. All resources in the portal framework database are scoped to the webapp.

  Returns
    a non-null webapp name.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2009, Oracle and/or its affiliates. All rights reserved.
Oracle is a registered trademark of Oracle Corporation and/or its affiliates.
Other names may be trademarks of their respective owners.